#pragma once

#include <stdbool.h>

/* regulated in JESD84-B51 */
#define EMMC_RSP_PRESENT (1 << 0)
#define EMMC_RSP_CRC (1 << 2)
#define EMMC_RSP_OPCODE (1 << 4)
#define EMMC_CMD_ADTC (1 << 5)
#define EMMC_RSP_SPI_S1 (1 << 7)
#define EMMC_RSP_SPI_R1 (EMMC_RSP_SPI_S1)
#define EMMC_RSP_R1 (EMMC_RSP_PRESENT | EMMC_RSP_CRC | EMMC_RSP_OPCODE)

#define EMMC_IOC_CMD _IOWR(MMC_BLOCK_MAJOR, 0, struct mmc_ioc_cmd)

#define EMMC_CMD_SET_TIME 49
#define EMMC_CMD_GEN_CMD 56
#define SSR_BUFF_SIZE 512 /** Secure Smart Report */
#define GEN_CMD_SSR 0x39 /** GEN_CMD arg for SSR feature */
#define OFFSET_CDATE 88 /** Offset bytes for completion date */
#define SECONDS_IN_A_DAY 86401
/** Offset seconds to convert to Gregorian time from epoch time */
#define EPOCH_OFFSET 62167219200
#define RTC_INFO_TYPE 1 /** payload block type for SET_TIME */

#define SUPPORTED_MID 0x13 /** micron */
#define SUPPORTED_REV 0x08 /** eMMC v5.1 */

extern int use_verbose;

// helpers.c
bool check_device(const char *dev);

// emmc-setup.c
int emmc_setup(const char *dev);
